#include <errno.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

int main(int argc, char** argv) {
  auto out_file = fopen(argv[2], "w");
  auto in_file = fopen(argv[1], "r");

  int in_fd = fileno(in_file);
  int out_fd = fileno(out_file);

  int new_argc = argc - 3;
  char** new_argv = (char**)malloc(sizeof(char*) * (new_argc + 1));

  new_argv[new_argc] = nullptr;

  for (int i = 0; i < new_argc; ++i) {
    char* arg = argv[3 + i];

    if (strcmp(argv[1], arg) == 0) {
      arg = (char*)malloc(32);
      sprintf(arg, "/dev/fd/%d", in_fd);
    } else if (strcmp(argv[2], arg) == 0) {
      arg = (char*)malloc(32);
      sprintf(arg, "/dev/fd/%d", out_fd);
    }

    new_argv[i] = arg;
  }

  int exec_ret = execvp(argv[3], new_argv);

  if (exec_ret == -1) {
    fprintf(stderr, "exec failed: errno = %d\n", errno);
  }
  return 1;
}
